| Flutter Impeller |

Classes | Public Types | Public Member Functions | Static Public Attributes | List of all members
impeller::Canvas Class Reference

`#include <canvas.h>`

## Classes
struct | SaveLayerState

## Public Types
using | BackdropFilterProc = std::function< std::shared_ptr< FilterContents >(FilterInput::Ref, const Matrix &effect_transform, Entity::RenderingMode rendering_mode)>

## Public Member Functions
| Canvas (ContentContext &renderer, const RenderTarget &render_target, bool is_onscreen, bool requires_readback)
| Canvas (ContentContext &renderer, const RenderTarget &render_target, bool is_onscreen, bool requires_readback, Rect cull_rect)
| Canvas (ContentContext &renderer, const RenderTarget &render_target, bool is_onscreen, bool requires_readback, IRect cull_rect)
| ~Canvas ()=default
void | SetBackdropData (std::unordered_map< int64_t, BackdropData > backdrop_data, size_t backdrop_count)
| Update the backdrop data used to group together backdrop filters within the same layer. More...
std::optional< Rect > | GetLocalCoverageLimit () const
| Return the culling bounds of the current render target, or nullopt if there is no coverage. More...
void | Save (uint32_t total_content_depth=kMaxDepth)
void | SaveLayer (const Paint &paint, std::optional< Rect > bounds=std::nullopt, const flutter::DlImageFilter *backdrop_filter=nullptr, ContentBoundsPromise bounds_promise=ContentBoundsPromise::kUnknown, uint32_t total_content_depth=kMaxDepth, bool can_distribute_opacity=false, std::optional< int64_t > backdrop_id=std::nullopt)
bool | Restore ()
size_t | GetSaveCount () const
void | RestoreToCount (size_t count)
const Matrix & | GetCurrentTransform () const
void | ResetTransform ()
void | Transform (const Matrix &transform)
void | Concat (const Matrix &transform)
void | PreConcat (const Matrix &transform)
void | Translate (const Vector3 &offset)
void | Scale (const Vector2 &scale)
void | Scale (const Vector3 &scale)
void | Skew (Scalar sx, Scalar sy)
void | Rotate (Radians radians)
void | DrawPath (const Path &path, const Paint &paint)
void | DrawPaint (const Paint &paint)
void | DrawLine (const Point &p0, const Point &p1, const Paint &paint, bool reuse_depth=false)
void | DrawRect (const Rect &rect, const Paint &paint)
void | DrawOval (const Rect &rect, const Paint &paint)
void | DrawRoundRect (const RoundRect &rect, const Paint &paint)
void | DrawRoundSuperellipse (const RoundSuperellipse &rse, const Paint &paint)
void | DrawCircle (const Point &center, Scalar radius, const Paint &paint)
void | DrawPoints (const Point points[], uint32_t count, Scalar radius, const Paint &paint, PointStyle point_style)
void | DrawImage (const std::shared_ptr< Texture > &image, Point offset, const Paint &paint, const SamplerDescriptor &sampler={})
void | DrawImageRect (const std::shared_ptr< Texture > &image, Rect source, Rect dest, const Paint &paint, const SamplerDescriptor &sampler={}, SourceRectConstraint src_rect_constraint=SourceRectConstraint::kFast)
void | DrawTextFrame (const std::shared_ptr< TextFrame > &text_frame, Point position, const Paint &paint)
void | DrawVertices (const std::shared_ptr< VerticesGeometry > &vertices, BlendMode blend_mode, const Paint &paint)
void | DrawAtlas (const std::shared_ptr< AtlasContents > &atlas_contents, const Paint &paint)
void | ClipGeometry (const Geometry &geometry, Entity::ClipOperation clip_op, bool is_aa=true)
void | EndReplay ()
uint64_t | GetOpDepth () const
uint64_t | GetMaxOpDepth () const
bool | RequiresReadback () const
bool | SupportsBlitToOnscreen () const
bool | EnsureFinalMipmapGeneration () const

## Static Public Attributes
static constexpr uint32_t | kMaxDepth = 1 << 24

## Detailed Description

Definition at line 116 of file canvas.h.

## Member Typedef Documentation

## ◆ BackdropFilterProc

using impeller::Canvas::BackdropFilterProc = std::function<std::shared_ptr<FilterContents>( FilterInput::Ref, const Matrix& effect_transform, Entity::RenderingMode rendering_mode)>

Definition at line 120 of file canvas.h.

## Constructor & Destructor Documentation

## ◆ Canvas() [1/3]

impeller::Canvas::Canvas | ( | ContentContext & | renderer,
|  | const RenderTarget & | render_target,
|  | bool | is_onscreen,
|  | bool | requires_readback
| ) |  |

Definition at line 180 of file canvas.cc.

184 : renderer_(renderer),
185 render_target_(render_target),
186 is_onscreen_(is_onscreen),
187 requires_readback_(requires_readback),
188 clip_coverage_stack_(EntityPassClipStack(
189 Rect::MakeSize(render_target.GetRenderTargetSize()))) {
190 Initialize(std::nullopt);
191 SetupRenderPass();
192 }
impeller::TRect< Scalar >::MakeSize
constexpr static TRect MakeSize(const TSize< U > &size)
Definition: rect.h:150

## ◆ Canvas() [2/3]

impeller::Canvas::Canvas | ( | ContentContext & | renderer,
|  | const RenderTarget & | render_target,
|  | bool | is_onscreen,
|  | bool | requires_readback,
|  | Rect | cull_rect
| ) |  |
| explicit

Definition at line 194 of file canvas.cc.

199 : renderer_(renderer),
200 render_target_(render_target),
201 is_onscreen_(is_onscreen),
202 requires_readback_(requires_readback),
203 clip_coverage_stack_(EntityPassClipStack(
204 Rect::MakeSize(render_target.GetRenderTargetSize()))) {
205 Initialize(cull_rect);
206 SetupRenderPass();
207 }

## ◆ Canvas() [3/3]

impeller::Canvas::Canvas | ( | ContentContext & | renderer,
|  | const RenderTarget & | render_target,
|  | bool | is_onscreen,
|  | bool | requires_readback,
|  | IRect | cull_rect
| ) |  |
| explicit

Definition at line 209 of file canvas.cc.

214 : renderer_(renderer),
215 render_target_(render_target),
216 is_onscreen_(is_onscreen),
217 requires_readback_(requires_readback),
218 clip_coverage_stack_(EntityPassClipStack(
219 Rect::MakeSize(render_target.GetRenderTargetSize()))) {
220 Initialize(Rect::MakeLTRB(cull_rect.GetLeft(), cull_rect.GetTop(),
221 cull_rect.GetRight(), cull_rect.GetBottom()));
222 SetupRenderPass();
223 }
impeller::TRect< Scalar >::MakeLTRB
constexpr static TRect MakeLTRB(Type left, Type top, Type right, Type bottom)
Definition: rect.h:129

References impeller::TRect< T >::GetBottom(), impeller::TRect< T >::GetLeft(), impeller::TRect< T >::GetRight(), impeller::TRect< T >::GetTop(), and impeller::TRect< Scalar >::MakeLTRB().

## ◆ ~Canvas()

impeller::Canvas::~Canvas | ( |  | ) |
| default

## Member Function Documentation

## ◆ ClipGeometry()

void impeller::Canvas::ClipGeometry | ( | const Geometry & | geometry,
|  | Entity::ClipOperation | clip_op,
|  | bool | is_aa = `true`
| ) |  |

Definition at line 686 of file canvas.cc.

688 {
689 if (IsSkipping()) {
690 return;
691 }
692
693 // Ideally the clip depth would be greater than the current rendering
694 // depth because any rendering calls that follow this clip operation will
695 // pre-increment the depth and then be rendering above our clip depth,
696 // but that case will be caught by the CHECK in AddRenderEntity above.
697 // In practice we sometimes have a clip set with no rendering after it
698 // and in such cases the current depth will equal the clip depth.
699 // Eventually the DisplayList should optimize these out, but it is hard
700 // to know if a clip will actually be used in advance of storing it in
701 // the DisplayList buffer.
702 // See https://github.com/flutter/flutter/issues/147021
703 FML_DCHECK(current_depth_ <= transform_stack_.back().clip_depth)
704 << current_depth_ << " <=? " << transform_stack_.back().clip_depth;
705 uint32_t clip_depth = transform_stack_.back().clip_depth;
706
707 const Matrix clip_transform =
708 Matrix::MakeTranslation(Vector3(-GetGlobalPassPosition())) *
709 GetCurrentTransform();
710
711 std::optional<Rect> clip_coverage = geometry.GetCoverage(clip_transform);
712 if (!clip_coverage.has_value()) {
713 return;
714 }
715
716 ClipContents clip_contents(
717 clip_coverage.value(),
718 /*is_axis_aligned_rect=*/geometry.IsAxisAlignedRect() &&
719 GetCurrentTransform().IsTranslationScaleOnly());
720 clip_contents.SetClipOperation(clip_op);
721
722 EntityPassClipStack::ClipStateResult clip_state_result =
723 clip_coverage_stack_.RecordClip(
724 clip_contents, //
725 /*transform=*/clip_transform, //
726 /*global_pass_position=*/GetGlobalPassPosition(), //
727 /*clip_depth=*/clip_depth, //
728 /*clip_height_floor=*/GetClipHeightFloor(), //
729 /*is_aa=*/is_aa);
730
731 if (clip_state_result.clip_did_change) {
732 // We only need to update the pass scissor if the clip state has changed.
733 SetClipScissor(clip_coverage_stack_.CurrentClipCoverage(),
734 *render_passes_.back().inline_pass_context->GetRenderPass(),
735 GetGlobalPassPosition());
736 }
737
738 ++transform_stack_.back().clip_height;
739 ++transform_stack_.back().num_clips;
740
741 if (!clip_state_result.should_render) {
742 return;
743 }
744
745 // Note: this is a bit of a hack. Its not possible to construct a geometry
746 // result without begninning the render pass. We should refactor the geometry
747 // objects so that they only need a reference to the render pass size and/or
748 // orthographic transform.
749 Entity entity;
750 entity.SetTransform(clip_transform);
751 entity.SetClipDepth(clip_depth);
752
753 GeometryResult geometry_result = geometry.GetPositionBuffer(
754 renderer_, //
755 entity, //
756 *render_passes_.back().inline_pass_context->GetRenderPass() //
757 );
758 clip_contents.SetGeometry(geometry_result);
759 clip_coverage_stack_.GetLastReplayResult().clip_contents.SetGeometry(
760 geometry_result);
761
762 clip_contents.Render(
763 renderer_, *render_passes_.back().inline_pass_context->GetRenderPass(),
764 clip_depth);
765 }
impeller::Canvas::GetCurrentTransform
const Matrix & GetCurrentTransform() const
Definition: canvas.cc:254
impeller::ClipContents::SetGeometry
void SetGeometry(GeometryResult geometry)
Set the pre-tessellated clip geometry.
Definition: clip_contents.cc:37
impeller::EntityPassClipStack::CurrentClipCoverage
std::optional< Rect > CurrentClipCoverage() const
Definition: entity_pass_clip_stack.cc:24
impeller::EntityPassClipStack::GetLastReplayResult
ReplayResult & GetLastReplayResult()
Definition: entity_pass_clip_stack.h:61
impeller::EntityPassClipStack::RecordClip
ClipStateResult RecordClip(const ClipContents &clip_contents, Matrix transform, Point global_pass_position, uint32_t clip_depth, size_t clip_height_floor, bool is_aa)
Definition: entity_pass_clip_stack.cc:100
impeller::EntityPassClipStack::ReplayResult::clip_contents
ClipContents clip_contents
Definition: entity_pass_clip_stack.h:26
impeller::Matrix::MakeTranslation
static constexpr Matrix MakeTranslation(const Vector3 &t)
Definition: matrix.h:95

References impeller::EntityPassClipStack::ReplayResult::clip_contents, impeller::EntityPassClipStack::ClipStateResult::clip_did_change, impeller::EntityPassClipStack::CurrentClipCoverage(), impeller::Geometry::GetCoverage(), GetCurrentTransform(), impeller::EntityPassClipStack::GetLastReplayResult(), impeller::Geometry::GetPositionBuffer(), impeller::Geometry::IsAxisAlignedRect(), impeller::Matrix::MakeTranslation(), impeller::EntityPassClipStack::RecordClip(), impeller::ClipContents::Render(), impeller::Entity::SetClipDepth(), impeller::ClipContents::SetClipOperation(), impeller::ClipContents::SetGeometry(), impeller::Entity::SetTransform(), and impeller::EntityPassClipStack::ClipStateResult::should_render.

Referenced by impeller::DlDispatcherBase::clipOval(), impeller::DlDispatcherBase::clipPath(), impeller::DlDispatcherBase::clipRect(), impeller::DlDispatcherBase::clipRoundRect(), and impeller::DlDispatcherBase::clipRoundSuperellipse().

## ◆ Concat()

void impeller::Canvas::Concat | ( | const Matrix & | transform | ) |

Definition at line 238 of file canvas.cc.

238 {
239 transform_stack_.back().transform = GetCurrentTransform() * transform;
240 }
transform
Matrix transform
Definition: gaussian_blur_filter_contents.cc:214

References GetCurrentTransform(), and transform.

Referenced by DrawTextFrame(), Rotate(), Scale(), Skew(), Transform(), and Translate().

## ◆ DrawAtlas()

void impeller::Canvas::DrawAtlas | ( | const std::shared_ptr< AtlasContents > & | atlas_contents,
|  | const Paint & | paint
| ) |  |

Definition at line 977 of file canvas.cc.

978 {
979 atlas_contents->SetAlpha(paint.color.alpha);
980
981 Entity entity;
982 entity.SetTransform(GetCurrentTransform());
983 entity.SetBlendMode(paint.blend_mode);
984 entity.SetContents(paint.WithFilters(atlas_contents));
985
986 AddRenderEntityToCurrentPass(entity);
987 }

References impeller::Color::alpha, impeller::Paint::blend_mode, impeller::Paint::color, GetCurrentTransform(), impeller::Entity::SetBlendMode(), impeller::Entity::SetContents(), impeller::Entity::SetTransform(), and impeller::Paint::WithFilters().

Referenced by impeller::DlDispatcherBase::drawAtlas().

## ◆ DrawCircle()

void impeller::Canvas::DrawCircle | ( | const Point & | center,
|  | Scalar | radius,
|  | const Paint & | paint
| ) |  |

Definition at line 663 of file canvas.cc.

665 {
666 Size half_size(radius, radius);
667 if (AttemptDrawBlurredRRect(
668 Rect::MakeOriginSize(center - half_size, half_size * 2),
669 {radius, radius}, paint)) {
670 return;
671 }
672
673 Entity entity;
674 entity.SetTransform(GetCurrentTransform());
675 entity.SetBlendMode(paint.blend_mode);
676
677 if (paint.style == Paint::Style::kStroke) {
678 CircleGeometry geom(center, radius, paint.stroke_width);
679 AddRenderEntityWithFiltersToCurrentPass(entity, &geom, paint);
680 } else {
681 CircleGeometry geom(center, radius);
682 AddRenderEntityWithFiltersToCurrentPass(entity, &geom, paint);
683 }
684 }
impeller::Size
TSize< Scalar > Size
Definition: size.h:159
impeller::Paint::Style::kStroke
@ kStroke
impeller::TRect< Scalar >::MakeOriginSize
constexpr static TRect MakeOriginSize(const TPoint< Type > &origin, const TSize< Type > &size)
Definition: rect.h:144

References impeller::Paint::blend_mode, GetCurrentTransform(), impeller::Paint::kStroke, impeller::TRect< Scalar >::MakeOriginSize(), impeller::Entity::SetBlendMode(), impeller::Entity::SetTransform(), impeller::Paint::stroke_width, and impeller::Paint::style.

Referenced by impeller::DlDispatcherBase::drawCircle(), and DrawOval().

## ◆ DrawImage()

void impeller::Canvas::DrawImage | ( | const std::shared_ptr< Texture > & | image,
|  | Point | offset,
|  | const Paint & | paint,
|  | const SamplerDescriptor & | sampler = `{}`
| ) |  |

Definition at line 785 of file canvas.cc.

788 {
789 if (!image) {
790 return;
791 }
792
793 const Rect source = Rect::MakeSize(image->GetSize());
794 const Rect dest = source.Shift(offset);
795
796 DrawImageRect(image, source, dest, paint, sampler);
797 }
impeller::Canvas::DrawImageRect
void DrawImageRect(const std::shared_ptr< Texture > &image, Rect source, Rect dest, const Paint &paint, const SamplerDescriptor &sampler={}, SourceRectConstraint src_rect_constraint=SourceRectConstraint::kFast)
Definition: canvas.cc:799
impeller::Rect
TRect< Scalar > Rect
Definition: rect.h:792
offset
SeparatedVector2 offset
Definition: stroke_path_geometry.cc:322
impeller::TRect::Shift
constexpr TRect< T > Shift(T dx, T dy) const
Returns a new rectangle translated by the given offset.
Definition: rect.h:606

References DrawImageRect(), impeller::TRect< Scalar >::MakeSize(), offset, and impeller::TRect< T >::Shift().

## ◆ DrawImageRect()

void impeller::Canvas::DrawImageRect | ( | const std::shared_ptr< Texture > & | image,
|  | Rect | source,
|  | Rect | dest,
|  | const Paint & | paint,
|  | const SamplerDescriptor & | sampler = `{}`,
|  | SourceRectConstraint | src_rect_constraint = `SourceRectConstraint::kFast`
| ) |  |

Definition at line 799 of file canvas.cc.

804 {
805 if (!image || source.IsEmpty() || dest.IsEmpty()) {
806 return;
807 }
808
809 ISize size = image->GetSize();
810 if (size.IsEmpty()) {
811 return;
812 }
813
814 std::optional<Rect> clipped_source =
815 source.Intersection(Rect::MakeSize(size));
816 if (!clipped_source) {
817 return;
818 }
819
820 if (AttemptColorFilterOptimization(image, source, dest, paint, sampler,
821 src_rect_constraint)) {
822 return;
823 }
824
825 if (*clipped_source != source) {
826 Scalar sx = dest.GetWidth() / source.GetWidth();
827 Scalar sy = dest.GetHeight() / source.GetHeight();
828 Scalar tx = dest.GetLeft() - source.GetLeft() * sx;
829 Scalar ty = dest.GetTop() - source.GetTop() * sy;
830 Matrix src_to_dest = Matrix::MakeTranslateScale({sx, sy, 1}, {tx, ty, 0});
831 dest = clipped_source->TransformBounds(src_to_dest);
832 }
833
834 auto texture_contents = TextureContents::MakeRect(dest);
835 texture_contents->SetTexture(image);
836 texture_contents->SetSourceRect(*clipped_source);
837 texture_contents->SetStrictSourceRect(src_rect_constraint ==
838 SourceRectConstraint::kStrict);
839 texture_contents->SetSamplerDescriptor(sampler);
840 texture_contents->SetOpacity(paint.color.alpha);
841 texture_contents->SetDeferApplyingOpacity(paint.HasColorFilter());
842
843 Entity entity;
844 entity.SetBlendMode(paint.blend_mode);
845 entity.SetTransform(GetCurrentTransform());
846
847 if (!paint.mask_blur_descriptor.has_value()) {
848 entity.SetContents(paint.WithFilters(std::move(texture_contents)));
849 AddRenderEntityToCurrentPass(entity);
850 return;
851 }
852
853 RectGeometry out_rect(Rect{});
854
855 entity.SetContents(paint.WithFilters(
856 paint.mask_blur_descriptor->CreateMaskBlur(texture_contents, &out_rect)));
857 AddRenderEntityToCurrentPass(entity);
858 }
impeller::TextureContents::MakeRect
static std::shared_ptr< TextureContents > MakeRect(Rect destination)
A common case factory that marks the texture contents as having a destination rectangle....
Definition: texture_contents.cc:28
impeller::Scalar
float Scalar
Definition: scalar.h:18
impeller::SourceRectConstraint::kStrict
@ kStrict
Sample only within the source rectangle. May be slower.
impeller::ISize
ISize64 ISize
Definition: size.h:162
impeller::Matrix::MakeTranslateScale
static constexpr Matrix MakeTranslateScale(const Vector3 &s, const Vector3 &t)
Definition: matrix.h:113

References impeller::Color::alpha, impeller::Paint::blend_mode, impeller::Paint::color, GetCurrentTransform(), impeller::TRect< T >::GetHeight(), impeller::TRect< T >::GetLeft(), impeller::TRect< T >::GetTop(), impeller::TRect< T >::GetWidth(), impeller::Paint::HasColorFilter(), impeller::TRect< T >::Intersection(), impeller::TRect< T >::IsEmpty(), impeller::TSize< T >::IsEmpty(), impeller::kStrict, impeller::TextureContents::MakeRect(), impeller::TRect< Scalar >::MakeSize(), impeller::Matrix::MakeTranslateScale(), impeller::Paint::mask_blur_descriptor, impeller::Entity::SetBlendMode(), impeller::Entity::SetContents(), impeller::Entity::SetTransform(), impeller::TRect< T >::TransformBounds(), and impeller::Paint::WithFilters().

Referenced by DrawImage(), impeller::DlDispatcherBase::drawImageRect(), and impeller::NinePatchConverter::DrawNinePatch().

## ◆ DrawLine()

void impeller::Canvas::DrawLine | ( | const Point & | p0,
|  | const Point & | p1,
|  | const Paint & | paint,
|  | bool | reuse_depth = `false`
| ) |  |

Definition at line 542 of file canvas.cc.

545 {
546 Entity entity;
547 entity.SetTransform(GetCurrentTransform());
548 entity.SetBlendMode(paint.blend_mode);
549
550 auto geometry = std::make_unique<LineGeometry>(p0, p1, paint.stroke_width,
551 paint.stroke_cap);
552
553 if (renderer_.GetContext()->GetFlags().antialiased_lines &&
554 !paint.color_filter && !paint.invert_colors && !paint.image_filter &&
555 !paint.mask_blur_descriptor.has_value() && !paint.color_source) {
556 auto contents = LineContents::Make(std::move(geometry), paint.color);
557 entity.SetContents(std::move(contents));
558 AddRenderEntityToCurrentPass(entity, reuse_depth);
559 } else {
560 AddRenderEntityWithFiltersToCurrentPass(entity, geometry.get(), paint,
561 /*reuse_depth=*/reuse_depth);
562 }
563 }
impeller::ContentContext::GetContext
std::shared_ptr< Context > GetContext() const
Definition: content_context.cc:913
impeller::LineContents::Make
static std::unique_ptr< LineContents > Make(std::unique_ptr< LineGeometry > geometry, Color color)
Definition: line_contents.cc:137

References impeller::Paint::blend_mode, impeller::Paint::color, impeller::Paint::color_filter, impeller::Paint::color_source, impeller::ContentContext::GetContext(), GetCurrentTransform(), impeller::Paint::image_filter, impeller::Paint::invert_colors, impeller::LineContents::Make(), impeller::Paint::mask_blur_descriptor, impeller::Entity::SetBlendMode(), impeller::Entity::SetContents(), impeller::Entity::SetTransform(), impeller::Paint::stroke_cap, and impeller::Paint::stroke_width.

Referenced by impeller::DlDispatcherBase::drawLine(), impeller::DlDispatcherBase::drawPoints(), and impeller::DlDispatcherBase::SimplifyOrDrawPath().

## ◆ DrawOval()

void impeller::Canvas::DrawOval | ( | const Rect & | rect,
|  | const Paint & | paint
| ) |  |

Definition at line 583 of file canvas.cc.

583 {
584 // TODO(jonahwilliams): This additional condition avoids an assert in the
585 // stroke circle geometry generator. I need to verify the condition that this
586 // assert prevents.
587 if (rect.IsSquare() && (paint.style == Paint::Style::kFill ||
588 (paint.style == Paint::Style::kStroke &&
589 paint.stroke_width < rect.GetWidth()))) {
590 // Circles have slightly less overhead and can do stroking
591 DrawCircle(rect.GetCenter(), rect.GetWidth() * 0.5f, paint);
592 return;
593 }
594
595 if (paint.style == Paint::Style::kStroke) {
596 // No stroked ellipses yet
597 DrawPath(PathBuilder{}.AddOval(rect).TakePath(), paint);
598 return;
599 }
600
601 if (AttemptDrawBlurredRRect(rect, rect.GetSize() * 0.5f, paint)) {
602 return;
603 }
604
605 Entity entity;
606 entity.SetTransform(GetCurrentTransform());
607 entity.SetBlendMode(paint.blend_mode);
608
609 EllipseGeometry geom(rect);
610 AddRenderEntityWithFiltersToCurrentPass(entity, &geom, paint);
611 }
impeller::Canvas::DrawPath
void DrawPath(const Path &path, const Paint &paint)
Definition: canvas.cc:309
impeller::Canvas::DrawCircle
void DrawCircle(const Point &center, Scalar radius, const Paint &paint)
Definition: canvas.cc:663
impeller::Paint::Style::kFill
@ kFill

References impeller::PathBuilder::AddOval(), impeller::Paint::blend_mode, DrawCircle(), DrawPath(), impeller::TRect< T >::GetCenter(), GetCurrentTransform(), impeller::TRect< T >::GetSize(), impeller::TRect< T >::GetWidth(), impeller::TRect< T >::IsSquare(), impeller::Paint::kFill, impeller::Paint::kStroke, impeller::Entity::SetBlendMode(), impeller::Entity::SetTransform(), impeller::Paint::stroke_width, and impeller::Paint::style.

Referenced by impeller::DlDispatcherBase::drawOval(), and impeller::DlDispatcherBase::SimplifyOrDrawPath().

## ◆ DrawPaint()

void impeller::Canvas::DrawPaint | ( | const Paint & | paint | ) |

Definition at line 324 of file canvas.cc.

324 {
325 Entity entity;
326 entity.SetTransform(GetCurrentTransform());
327 entity.SetBlendMode(paint.blend_mode);
328
329 CoverGeometry geom;
330 AddRenderEntityWithFiltersToCurrentPass(entity, &geom, paint);
331 }

References impeller::Paint::blend_mode, GetCurrentTransform(), impeller::Entity::SetBlendMode(), and impeller::Entity::SetTransform().

Referenced by impeller::DlDispatcherBase::drawColor(), and impeller::DlDispatcherBase::drawPaint().

## ◆ DrawPath()

void impeller::Canvas::DrawPath | ( | const Path & | path,
|  | const Paint & | paint
| ) |  |

Definition at line 309 of file canvas.cc.

309 {
310 Entity entity;
311 entity.SetTransform(GetCurrentTransform());
312 entity.SetBlendMode(paint.blend_mode);
313
314 if (paint.style == Paint::Style::kFill) {
315 FillPathGeometry geom(path);
316 AddRenderEntityWithFiltersToCurrentPass(entity, &geom, paint);
317 } else {
318 StrokePathGeometry geom(path, paint.stroke_width, paint.stroke_miter,
319 paint.stroke_cap, paint.stroke_join);
320 AddRenderEntityWithFiltersToCurrentPass(entity, &geom, paint);
321 }
322 }

References impeller::Paint::blend_mode, GetCurrentTransform(), impeller::Paint::kFill, impeller::Entity::SetBlendMode(), impeller::Entity::SetTransform(), impeller::Paint::stroke_cap, impeller::Paint::stroke_join, impeller::Paint::stroke_miter, impeller::Paint::stroke_width, and impeller::Paint::style.

Referenced by impeller::DlDispatcherBase::drawArc(), impeller::DlDispatcherBase::drawDashedLine(), impeller::DlDispatcherBase::drawDiffRoundRect(), DrawOval(), DrawRect(), DrawRoundRect(), DrawRoundSuperellipse(), DrawTextFrame(), and impeller::DlDispatcherBase::SimplifyOrDrawPath().

## ◆ DrawPoints()

void impeller::Canvas::DrawPoints | ( | const Point | points[],
|  | uint32_t | count,
|  | Scalar | radius,
|  | const Paint & | paint,
|  | PointStyle | point_style
| ) |  |

Definition at line 767 of file canvas.cc.

771 {
772 if (radius <= 0) {
773 return;
774 }
775
776 Entity entity;
777 entity.SetTransform(GetCurrentTransform());
778 entity.SetBlendMode(paint.blend_mode);
779
780 PointFieldGeometry geom(points, count, radius,
781 /*round=*/point_style == PointStyle::kRound);
782 AddRenderEntityWithFiltersToCurrentPass(entity, &geom, paint);
783 }
impeller::PointStyle::kRound
@ kRound
Points are drawn as squares.

References impeller::Paint::blend_mode, GetCurrentTransform(), impeller::kRound, impeller::Entity::SetBlendMode(), and impeller::Entity::SetTransform().

Referenced by impeller::DlDispatcherBase::drawPoints().

## ◆ DrawRect()

void impeller::Canvas::DrawRect | ( | const Rect & | rect,
|  | const Paint & | paint
| ) |  |

Definition at line 565 of file canvas.cc.

565 {
566 if (paint.style == Paint::Style::kStroke) {
567 DrawPath(PathBuilder{}.AddRect(rect).TakePath(), paint);
568 return;
569 }
570
571 if (AttemptDrawBlurredRRect(rect, {}, paint)) {
572 return;
573 }
574
575 Entity entity;
576 entity.SetTransform(GetCurrentTransform());
577 entity.SetBlendMode(paint.blend_mode);
578
579 RectGeometry geom(rect);
580 AddRenderEntityWithFiltersToCurrentPass(entity, &geom, paint);
581 }

References impeller::PathBuilder::AddRect(), impeller::Paint::blend_mode, DrawPath(), GetCurrentTransform(), impeller::Paint::kStroke, impeller::Entity::SetBlendMode(), impeller::Entity::SetTransform(), and impeller::Paint::style.

Referenced by impeller::DlDispatcherBase::drawRect(), and impeller::DlDispatcherBase::SimplifyOrDrawPath().

## ◆ DrawRoundRect()

void impeller::Canvas::DrawRoundRect | ( | const RoundRect & | rect,
|  | const Paint & | paint
| ) |  |

Definition at line 613 of file canvas.cc.

613 {
614 auto& rect = round_rect.GetBounds();
615 auto& radii = round_rect.GetRadii();
616 if (radii.AreAllCornersSame()) {
617 if (AttemptDrawBlurredRRect(rect, radii.top_left, paint)) {
618 return;
619 }
620
621 if (paint.style == Paint::Style::kFill) {
622 Entity entity;
623 entity.SetTransform(GetCurrentTransform());
624 entity.SetBlendMode(paint.blend_mode);
625
626 RoundRectGeometry geom(rect, radii.top_left);
627 AddRenderEntityWithFiltersToCurrentPass(entity, &geom, paint);
628 return;
629 }
630 }
631
632 auto path = PathBuilder{}
633 .SetConvexity(Convexity::kConvex)
634 .AddRoundRect(round_rect)
635 .SetBounds(rect)
636 .TakePath();
637 DrawPath(path, paint);
638 }
impeller::Convexity::kConvex
@ kConvex

References impeller::PathBuilder::AddRoundRect(), impeller::Paint::blend_mode, DrawPath(), impeller::RoundRect::GetBounds(), GetCurrentTransform(), impeller::RoundRect::GetRadii(), impeller::kConvex, impeller::Paint::kFill, impeller::Entity::SetBlendMode(), impeller::PathBuilder::SetBounds(), impeller::PathBuilder::SetConvexity(), impeller::Entity::SetTransform(), impeller::Paint::style, and impeller::PathBuilder::TakePath().

Referenced by impeller::DlDispatcherBase::drawRoundRect(), and impeller::DlDispatcherBase::SimplifyOrDrawPath().

## ◆ DrawRoundSuperellipse()

void impeller::Canvas::DrawRoundSuperellipse | ( | const RoundSuperellipse & | rse,
|  | const Paint & | paint
| ) |  |

Definition at line 640 of file canvas.cc.

641 {
642 if (paint.style == Paint::Style::kFill) {
643 // TODO(dkwingsmt): Investigate if RSE can use the `AttemptDrawBlurredRRect`
644 // optimization at some point, such as a large enough mask radius.
645 // https://github.com/flutter/flutter/issues/163893
646 Entity entity;
647 entity.SetTransform(GetCurrentTransform());
648 entity.SetBlendMode(paint.blend_mode);
649
650 RoundSuperellipseGeometry geom(rse.GetBounds(), rse.GetRadii());
651 AddRenderEntityWithFiltersToCurrentPass(entity, &geom, paint);
652 return;
653 }
654
655 auto path = PathBuilder{}
656 .SetConvexity(Convexity::kConvex)
657 .AddRoundSuperellipse(rse)
658 .SetBounds(rse.GetBounds())
659 .TakePath();
660 DrawPath(path, paint);
661 }

References impeller::PathBuilder::AddRoundSuperellipse(), impeller::Paint::blend_mode, DrawPath(), impeller::RoundSuperellipse::GetBounds(), GetCurrentTransform(), impeller::RoundSuperellipse::GetRadii(), impeller::kConvex, impeller::Paint::kFill, impeller::Entity::SetBlendMode(), impeller::PathBuilder::SetBounds(), impeller::PathBuilder::SetConvexity(), impeller::Entity::SetTransform(), impeller::Paint::style, and impeller::PathBuilder::TakePath().

Referenced by impeller::DlDispatcherBase::drawRoundSuperellipse().

## ◆ DrawTextFrame()

void impeller::Canvas::DrawTextFrame | ( | const std::shared_ptr< TextFrame > & | text_frame,
|  | Point | position,
|  | const Paint & | paint
| ) |  |

Definition at line 1520 of file canvas.cc.

1522 {
1523 Scalar max_scale = GetCurrentTransform().GetMaxBasisLengthXY();
1524 if (max_scale * text_frame->GetFont().GetMetrics().point_size >
1525 kMaxTextScale) {
1526 fml::StatusOr<flutter::DlPath> path = text_frame->GetPath();
1527 if (path.ok()) {
1528 Save(1);
1529 Concat(Matrix::MakeTranslation(position));
1530 DrawPath(path.value().GetPath(), paint);
1531 Restore();
1532 return;
1533 }
1534 }
1535
1536 Entity entity;
1537 entity.SetClipDepth(GetClipHeight());
1538 entity.SetBlendMode(paint.blend_mode);
1539
1540 auto text_contents = std::make_shared<TextContents>();
1541 text_contents->SetTextFrame(text_frame);
1542 text_contents->SetForceTextColor(paint.mask_blur_descriptor.has_value());
1543 text_contents->SetScale(max_scale);
1544 text_contents->SetColor(paint.color);
1545 text_contents->SetOffset(position);
1546 text_contents->SetTextProperties(paint.color, //
1547 paint.style == Paint::Style::kStroke, //
1548 paint.stroke_width, //
1549 paint.stroke_cap, //
1550 paint.stroke_join, //
1551 paint.stroke_miter //
1552 );
1553
1554 entity.SetTransform(GetCurrentTransform() *
1555 Matrix::MakeTranslation(position));
1556
1557 if (AttemptBlurredTextOptimization(text_frame, text_contents, entity,
1558 paint)) {
1559 return;
1560 }
1561
1562 entity.SetContents(paint.WithFilters(std::move(text_contents)));
1563 AddRenderEntityToCurrentPass(entity, false);
1564 }
impeller::Canvas::Restore
bool Restore()
Definition: canvas.cc:1329
impeller::Canvas::Concat
void Concat(const Matrix &transform)
Definition: canvas.cc:238
impeller::Canvas::Save
void Save(uint32_t total_content_depth=kMaxDepth)
Definition: canvas.cc:1043
impeller::kMaxTextScale
static constexpr Scalar kMaxTextScale
Definition: canvas.cc:1518
impeller::Matrix::GetMaxBasisLengthXY
constexpr Scalar GetMaxBasisLengthXY() const
Definition: matrix.h:323

References impeller::Paint::blend_mode, impeller::Paint::color, Concat(), DrawPath(), GetCurrentTransform(), impeller::Matrix::GetMaxBasisLengthXY(), impeller::kMaxTextScale, impeller::Paint::kStroke, impeller::Matrix::MakeTranslation(), impeller::Paint::mask_blur_descriptor, Restore(), Save(), impeller::Entity::SetBlendMode(), impeller::Entity::SetClipDepth(), impeller::Entity::SetContents(), impeller::Entity::SetTransform(), impeller::Paint::stroke_cap, impeller::Paint::stroke_join, impeller::Paint::stroke_miter, impeller::Paint::stroke_width, impeller::Paint::style, and impeller::Paint::WithFilters().

Referenced by impeller::DlDispatcherBase::drawTextFrame().

## ◆ DrawVertices()

void impeller::Canvas::DrawVertices | ( | const std::shared_ptr< VerticesGeometry > & | vertices,
|  | BlendMode | blend_mode,
|  | const Paint & | paint
| ) |  |

Definition at line 864 of file canvas.cc.

866 {
867 // Override the blend mode with kDestination in order to match the behavior
868 // of Skia's SK_LEGACY_IGNORE_DRAW_VERTICES_BLEND_WITH_NO_SHADER flag, which
869 // is enabled when the Flutter engine builds Skia.
870 if (!paint.color_source) {
871 blend_mode = BlendMode::kDst;
872 }
873
874 Entity entity;
875 entity.SetTransform(GetCurrentTransform());
876 entity.SetBlendMode(paint.blend_mode);
877
878 // If there are no vertex colors.
879 if (UseColorSourceContents(vertices, paint)) {
880 AddRenderEntityWithFiltersToCurrentPass(entity, vertices.get(), paint);
881 return;
882 }
883
884 // If the blend mode is destination don't bother to bind or create a texture.
885 if (blend_mode == BlendMode::kDst) {
886 auto contents = std::make_shared<VerticesSimpleBlendContents>();
887 contents->SetBlendMode(blend_mode);
888 contents->SetAlpha(paint.color.alpha);
889 contents->SetGeometry(vertices);
890 entity.SetContents(paint.WithFilters(std::move(contents)));
891 AddRenderEntityToCurrentPass(entity);
892 return;
893 }
894
895 // If there is a texture, use this directly. Otherwise render the color
896 // source to a texture.
897 if (paint.color_source &&
898 paint.color_source->type() == flutter::DlColorSourceType::kImage) {
899 const flutter::DlImageColorSource* image_color_source =
900 paint.color_source->asImage();
901 FML_DCHECK(image_color_source &&
902 image_color_source->image()->impeller_texture());
903 auto texture = image_color_source->image()->impeller_texture();
904 auto x_tile_mode = static_cast<Entity::TileMode>(
905 image_color_source->horizontal_tile_mode());
906 auto y_tile_mode =
907 static_cast<Entity::TileMode>(image_color_source->vertical_tile_mode());
908 auto sampler_descriptor =
909 skia_conversions::ToSamplerDescriptor(image_color_source->sampling());
910 auto effect_transform = image_color_source->matrix();
911
912 auto contents = std::make_shared<VerticesSimpleBlendContents>();
913 contents->SetBlendMode(blend_mode);
914 contents->SetAlpha(paint.color.alpha);
915 contents->SetGeometry(vertices);
916 contents->SetEffectTransform(effect_transform);
917 contents->SetTexture(texture);
918 contents->SetTileMode(x_tile_mode, y_tile_mode);
919 contents->SetSamplerDescriptor(sampler_descriptor);
920
921 entity.SetContents(paint.WithFilters(std::move(contents)));
922 AddRenderEntityToCurrentPass(entity);
923 return;
924 }
925
926 auto src_paint = paint;
927 src_paint.color = paint.color.WithAlpha(1.0);
928
929 std::shared_ptr<ColorSourceContents> src_contents =
930 src_paint.CreateContents();
931 src_contents->SetGeometry(vertices.get());
932
933 // If the color source has an intrinsic size, then we use that to
934 // create the src contents as a simplification. Otherwise we use
935 // the extent of the texture coordinates to determine how large
936 // the src contents should be. If neither has a value we fall back
937 // to using the geometry coverage data.
938 Rect src_coverage;
939 auto size = src_contents->GetColorSourceSize();
940 if (size.has_value()) {
941 src_coverage = Rect::MakeXYWH(0, 0, size->width, size->height);
942 } else {
943 auto cvg = vertices->GetCoverage(Matrix{});
944 FML_CHECK(cvg.has_value());
945 auto texture_coverage = vertices->GetTextureCoordinateCoverage();
946 if (texture_coverage.has_value()) {
947 src_coverage =
948 Rect::MakeOriginSize(texture_coverage->GetOrigin(),
949 texture_coverage->GetSize().Max({1, 1}));
950 } else {
951 src_coverage = cvg.value();
952 }
953 }
954 src_contents = src_paint.CreateContents();
955
956 clip_geometry_.push_back(Geometry::MakeRect(Rect::Round(src_coverage)));
957 src_contents->SetGeometry(clip_geometry_.back().get());
958
959 auto contents = std::make_shared<VerticesSimpleBlendContents>();
960 contents->SetBlendMode(blend_mode);
961 contents->SetAlpha(paint.color.alpha);
962 contents->SetGeometry(vertices);
963 contents->SetLazyTextureCoverage(src_coverage);
964 contents->SetLazyTexture([src_contents,
965 src_coverage](const ContentContext& renderer) {
966 // Applying the src coverage as the coverage limit prevents the 1px
967 // coverage pad from adding a border that is picked up by developer
968 // specified UVs.
969 auto snapshot =
970 src_contents->RenderToSnapshot(renderer, {}, Rect::Round(src_coverage));
971 return snapshot.has_value() ? snapshot->texture : nullptr;
972 });
973 entity.SetContents(paint.WithFilters(std::move(contents)));
974 AddRenderEntityToCurrentPass(entity);
975 }
impeller::Entity::TileMode
TileMode
Definition: entity.h:42
impeller::Geometry::MakeRect
static std::unique_ptr< Geometry > MakeRect(const Rect &rect)
Definition: geometry.cc:84
impeller::skia_conversions::ToSamplerDescriptor
impeller::SamplerDescriptor ToSamplerDescriptor(const flutter::DlImageSampling options)
Definition: skia_conversions.cc:24
impeller::BlendMode::kDst
@ kDst
impeller::TRect< Scalar >::Round
Round(const TRect< U > &r)
Definition: rect.h:699
impeller::TRect< Scalar >::MakeXYWH
constexpr static TRect MakeXYWH(Type x, Type y, Type width, Type height)
Definition: rect.h:136

References impeller::Color::alpha, impeller::Paint::blend_mode, impeller::Paint::color, impeller::Paint::color_source, GetCurrentTransform(), impeller::kDst, impeller::TRect< Scalar >::MakeOriginSize(), impeller::Geometry::MakeRect(), impeller::TRect< Scalar >::MakeXYWH(), impeller::TRect< Scalar >::Round(), impeller::Entity::SetBlendMode(), impeller::Entity::SetContents(), impeller::Entity::SetTransform(), impeller::skia_conversions::ToSamplerDescriptor(), impeller::Color::WithAlpha(), and impeller::Paint::WithFilters().

Referenced by impeller::CanvasDlDispatcher::drawVertices(), and impeller::testing::TEST_P().

## ◆ EndReplay()

void impeller::Canvas::EndReplay | ( |  | ) |

Definition at line 1943 of file canvas.cc.

1943 {
1944 FML_DCHECK(render_passes_.size() == 1u);
1945 render_passes_.back().inline_pass_context->GetRenderPass();
1946 render_passes_.back().inline_pass_context->EndPass(
1947 /*is_onscreen=*/!requires_readback_ && is_onscreen_);
1948 backdrop_data_.clear();
1949
1950 // If requires_readback_ was true, then we rendered to an offscreen texture
1951 // instead of to the onscreen provided in the render target. Now we need to
1952 // draw or blit the offscreen back to the onscreen.
1953 if (requires_readback_) {
1954 BlitToOnscreen(/*is_onscreen_=*/is_onscreen_);
1955 }
1956 if (!EnsureFinalMipmapGeneration()) {
1957 VALIDATION_LOG << "Failed to generate onscreen mipmaps.";
1958 }
1959 if (!renderer_.GetContext()->FlushCommandBuffers()) {
1960 // Not much we can do.
1961 VALIDATION_LOG << "Failed to submit command buffers";
1962 }
1963 render_passes_.clear();
1964 renderer_.GetRenderTargetCache()->End();
1965 clip_geometry_.clear();
1966
1967 Reset();
1968 Initialize(initial_cull_rect_);
1969 }
impeller::Canvas::EnsureFinalMipmapGeneration
bool EnsureFinalMipmapGeneration() const
Definition: canvas.cc:1925
impeller::ContentContext::GetRenderTargetCache
const std::shared_ptr< RenderTargetAllocator > & GetRenderTargetCache() const
Definition: content_context.h:268
VALIDATION_LOG
#define VALIDATION_LOG
Definition: validation.h:91

References VALIDATION_LOG.

Referenced by impeller::CanvasDlDispatcher::FinishRecording(), and impeller::testing::TEST_P().

## ◆ EnsureFinalMipmapGeneration()

bool impeller::Canvas::EnsureFinalMipmapGeneration | ( |  | ) | const

For picture snapshots we need addition steps to verify that final mipmaps are generated.

Definition at line 1925 of file canvas.cc.

1925 {
1926 if (!render_target_.GetRenderTargetTexture()->NeedsMipmapGeneration()) {
1927 return true;
1928 }
1929 std::shared_ptr<CommandBuffer> cmd_buffer =
1930 renderer_.GetContext()->CreateCommandBuffer();
1931 if (!cmd_buffer) {
1932 return false;
1933 }
1934 std::shared_ptr<BlitPass> blit_pass = cmd_buffer->CreateBlitPass();
1935 if (!blit_pass) {
1936 return false;
1937 }
1938 blit_pass->GenerateMipmap(render_target_.GetRenderTargetTexture());
1939 blit_pass->EncodeCommands();
1940 return renderer_.GetContext()->EnqueueCommandBuffer(std::move(cmd_buffer));
1941 }
impeller::RenderTarget::GetRenderTargetTexture
std::shared_ptr< Texture > GetRenderTargetTexture() const
Definition: render_target.cc:176

## ◆ GetCurrentTransform()

const Matrix & impeller::Canvas::GetCurrentTransform | ( |  | ) | const

Definition at line 254 of file canvas.cc.

254 {
255 return transform_stack_.back().transform;
256 }

Referenced by ClipGeometry(), Concat(), DrawAtlas(), DrawCircle(), impeller::DlDispatcherBase::drawDisplayList(), DrawImageRect(), DrawLine(), DrawOval(), DrawPaint(), DrawPath(), DrawPoints(), DrawRect(), DrawRoundRect(), DrawRoundSuperellipse(), impeller::DlDispatcherBase::drawShadow(), DrawTextFrame(), DrawVertices(), and PreConcat().

## ◆ GetLocalCoverageLimit()

std::optional< Rect > impeller::Canvas::GetLocalCoverageLimit | ( |  | ) | const

Return the culling bounds of the current render target, or nullopt if there is no coverage.

Definition at line 1060 of file canvas.cc.

1060 {
1061 if (!clip_coverage_stack_.HasCoverage()) {
1062 // The current clip is empty. This means the pass texture won't be
1063 // visible, so skip it.
1064 return std::nullopt;
1065 }
1066
1067 auto maybe_current_clip_coverage = clip_coverage_stack_.CurrentClipCoverage();
1068 if (!maybe_current_clip_coverage.has_value()) {
1069 return std::nullopt;
1070 }
1071
1072 auto current_clip_coverage = maybe_current_clip_coverage.value();
1073
1074 // The maximum coverage of the subpass. Subpasses textures should never
1075 // extend outside the parent pass texture or the current clip coverage.
1076 std::optional<Rect> maybe_coverage_limit =
1077 Rect::MakeOriginSize(GetGlobalPassPosition(),
1078 Size(render_passes_.back()
1079 .inline_pass_context->GetTexture()
1080 ->GetSize()))
1081 .Intersection(current_clip_coverage);
1082
1083 if (!maybe_coverage_limit.has_value() || maybe_coverage_limit->IsEmpty()) {
1084 return std::nullopt;
1085 }
1086
1087 return maybe_coverage_limit->Intersection(
1088 Rect::MakeSize(render_target_.GetRenderTargetSize()));
1089 }
impeller::EntityPassClipStack::HasCoverage
bool HasCoverage() const
Definition: entity_pass_clip_stack.cc:28
impeller::RenderTarget::GetRenderTargetSize
ISize GetRenderTargetSize() const
Definition: render_target.cc:171
impeller::TRect::Intersection
constexpr std::optional< TRect > Intersection(const TRect &o) const
Definition: rect.h:532

References impeller::EntityPassClipStack::CurrentClipCoverage(), impeller::RenderTarget::GetRenderTargetSize(), impeller::EntityPassClipStack::HasCoverage(), impeller::TRect< T >::Intersection(), impeller::TRect< Scalar >::MakeOriginSize(), and impeller::TRect< Scalar >::MakeSize().

Referenced by impeller::DlDispatcherBase::drawDisplayList(), and SaveLayer().

## ◆ GetMaxOpDepth()

uint64_t impeller::Canvas::GetMaxOpDepth | ( |  | ) | const
| inline

Definition at line 247 of file canvas.h.

247 { return transform_stack_.back().clip_depth; }

Referenced by impeller::CanvasDlDispatcher::saveLayer().

## ◆ GetOpDepth()

uint64_t impeller::Canvas::GetOpDepth | ( |  | ) | const
| inline

Definition at line 245 of file canvas.h.

245 { return current_depth_; }

Referenced by impeller::CanvasDlDispatcher::saveLayer().

## ◆ GetSaveCount()

size_t impeller::Canvas::GetSaveCount | ( |  | ) | const

Definition at line 293 of file canvas.cc.

293 {
294 return transform_stack_.size();
295 }

Referenced by impeller::DlDispatcherBase::drawDisplayList(), and RestoreToCount().

## ◆ PreConcat()

void impeller::Canvas::PreConcat | ( | const Matrix & | transform | ) |

Definition at line 242 of file canvas.cc.

242 {
243 transform_stack_.back().transform = transform * GetCurrentTransform();
244 }

References GetCurrentTransform(), and transform.

Referenced by impeller::DlDispatcherBase::drawShadow().

## ◆ RequiresReadback()

bool impeller::Canvas::RequiresReadback | ( |  | ) | const
| inline

Definition at line 255 of file canvas.h.

255 { return requires_readback_; }

## ◆ ResetTransform()

void impeller::Canvas::ResetTransform | ( |  | ) |

Definition at line 246 of file canvas.cc.

246 {
247 transform_stack_.back().transform = {};
248 }

Referenced by impeller::DlDispatcherBase::transformReset().

## ◆ Restore()

bool impeller::Canvas::Restore | ( |  | ) |

Definition at line 1329 of file canvas.cc.

1329 {
1330 FML_DCHECK(transform_stack_.size() > 0);
1331 if (transform_stack_.size() == 1) {
1332 return false;
1333 }
1334
1335 // This check is important to make sure we didn't exceed the depth
1336 // that the clips were rendered at while rendering any of the
1337 // rendering ops. It is OK for the current depth to equal the
1338 // outgoing clip depth because that means the clipping would have
1339 // been successful up through the last rendering op, but it cannot
1340 // be greater.
1341 // Also, we bump the current rendering depth to the outgoing clip
1342 // depth so that future rendering operations are not clipped by
1343 // any of the pixels set by the expiring clips. It is OK for the
1344 // estimates used to determine the clip depth in save/saveLayer
1345 // to be overly conservative, but we need to jump the depth to
1346 // the clip depth so that the next rendering op will get a
1347 // larger depth (it will pre-increment the current_depth_ value).
1348 FML_DCHECK(current_depth_ <= transform_stack_.back().clip_depth)
1349 << current_depth_ << " <=? " << transform_stack_.back().clip_depth;
1350 current_depth_ = transform_stack_.back().clip_depth;
1351
1352 if (IsSkipping()) {
1353 transform_stack_.pop_back();
1354 return true;
1355 }
1356
1357 if (transform_stack_.back().rendering_mode ==
1358 Entity::RenderingMode::kSubpassAppendSnapshotTransform ||
1359 transform_stack_.back().rendering_mode ==
1360 Entity::RenderingMode::kSubpassPrependSnapshotTransform) {
1361 auto lazy_render_pass = std::move(render_passes_.back());
1362 render_passes_.pop_back();
1363 // Force the render pass to be constructed if it never was.
1364 lazy_render_pass.inline_pass_context->GetRenderPass();
1365
1366 SaveLayerState save_layer_state = save_layer_state_.back();
1367 save_layer_state_.pop_back();
1368 auto global_pass_position = GetGlobalPassPosition();
1369
1370 std::shared_ptr<Contents> contents = CreateContentsForSubpassTarget(
1371 save_layer_state.paint, //
1372 lazy_render_pass.inline_pass_context->GetTexture(), //
1373 Matrix::MakeTranslation(Vector3{-global_pass_position}) * //
1374 transform_stack_.back().transform //
1375 );
1376
1377 lazy_render_pass.inline_pass_context->EndPass();
1378
1379 // Round the subpass texture position for pixel alignment with the parent
1380 // pass render target. By default, we draw subpass textures with nearest
1381 // sampling, so aligning here is important for avoiding visual nearest
1382 // sampling errors caused by limited floating point precision when
1383 // straddling a half pixel boundary.
1384 Point subpass_texture_position;
1385 if (transform_stack_.back().did_round_out) {
1386 // Subpass coverage was rounded out, origin potentially moved "down" by
1387 // as much as a pixel.
1388 subpass_texture_position =
1389 (save_layer_state.coverage.GetOrigin() - global_pass_position)
1390 .Floor();
1391 } else {
1392 // Subpass coverage was truncated. Pick the closest phyiscal pixel.
1393 subpass_texture_position =
1394 (save_layer_state.coverage.GetOrigin() - global_pass_position)
1395 .Round();
1396 }
1397
1398 Entity element_entity;
1399 element_entity.SetClipDepth(++current_depth_);
1400 element_entity.SetContents(std::move(contents));
1401 element_entity.SetBlendMode(save_layer_state.paint.blend_mode);
1402 element_entity.SetTransform(
1403 Matrix::MakeTranslation(Vector3(subpass_texture_position)));
1404
1405 if (element_entity.GetBlendMode() > Entity::kLastPipelineBlendMode) {
1406 if (renderer_.GetDeviceCapabilities().SupportsFramebufferFetch()) {
1407 ApplyFramebufferBlend(element_entity);
1408 } else {
1409 // End the active pass and flush the buffer before rendering "advanced"
1410 // blends. Advanced blends work by binding the current render target
1411 // texture as an input ("destination"), blending with a second texture
1412 // input ("source"), writing the result to an intermediate texture, and
1413 // finally copying the data from the intermediate texture back to the
1414 // render target texture. And so all of the commands that have written
1415 // to the render target texture so far need to execute before it's bound
1416 // for blending (otherwise the blend pass will end up executing before
1417 // all the previous commands in the active pass).
1418 auto input_texture = FlipBackdrop(GetGlobalPassPosition());
1419 if (!input_texture) {
1420 return false;
1421 }
1422
1423 FilterInput::Vector inputs = {
1424 FilterInput::Make(input_texture,
1425 element_entity.GetTransform().Invert()),
1426 FilterInput::Make(element_entity.GetContents())};
1427 auto contents = ColorFilterContents::MakeBlend(
1428 element_entity.GetBlendMode(), inputs);
1429 contents->SetCoverageHint(element_entity.GetCoverage());
1430 element_entity.SetContents(std::move(contents));
1431 element_entity.SetBlendMode(BlendMode::kSrc);
1432 }
1433 }
1434
1435 element_entity.Render(
1436 renderer_, //
1437 *render_passes_.back().inline_pass_context->GetRenderPass() //
1438 );
1439 clip_coverage_stack_.PopSubpass();
1440 transform_stack_.pop_back();
1441
1442 // We don't need to restore clips if a saveLayer was performed, as the clip
1443 // state is per render target, and no more rendering operations will be
1444 // performed as the render target workloaded is completed in the restore.
1445 return true;
1446 }
1447
1448 size_t num_clips = transform_stack_.back().num_clips;
1449 transform_stack_.pop_back();
1450
1451 if (num_clips > 0) {
1452 EntityPassClipStack::ClipStateResult clip_state_result =
1453 clip_coverage_stack_.RecordRestore(GetGlobalPassPosition(),
1454 GetClipHeight());
1455
1456 // Clip restores are never required with depth based clipping.
1457 FML_DCHECK(!clip_state_result.should_render);
1458 if (clip_state_result.clip_did_change) {
1459 // We only need to update the pass scissor if the clip state has changed.
1460 SetClipScissor(
1461 clip_coverage_stack_.CurrentClipCoverage(), //
1462 *render_passes_.back().inline_pass_context->GetRenderPass(), //
1463 GetGlobalPassPosition() //
1464 );
1465 }
1466 }
1467
1468 return true;
1469 }
impeller::Capabilities::SupportsFramebufferFetch
virtual bool SupportsFramebufferFetch() const =0
Whether the context backend is able to support pipelines with shaders that read from the framebuffer ...
impeller::ColorFilterContents::MakeBlend
static std::shared_ptr< ColorFilterContents > MakeBlend(BlendMode blend_mode, FilterInput::Vector inputs, std::optional< Color > foreground_color=std::nullopt)
the [inputs] are expected to be in the order of dst, src.
Definition: color_filter_contents.cc:17
impeller::ContentContext::GetDeviceCapabilities
const Capabilities & GetDeviceCapabilities() const
Definition: content_context.cc:917
impeller::Entity::RenderingMode::kSubpassPrependSnapshotTransform
@ kSubpassPrependSnapshotTransform
impeller::Entity::RenderingMode::kSubpassAppendSnapshotTransform
@ kSubpassAppendSnapshotTransform
impeller::Entity::kLastPipelineBlendMode
static constexpr BlendMode kLastPipelineBlendMode
Definition: entity.h:22
impeller::EntityPassClipStack::RecordRestore
ClipStateResult RecordRestore(Point global_pass_position, size_t restore_height)
Definition: entity_pass_clip_stack.cc:54
impeller::EntityPassClipStack::PopSubpass
void PopSubpass()
Definition: entity_pass_clip_stack.cc:44
impeller::FilterInput::Make
static FilterInput::Ref Make(Variant input, bool msaa_enabled=true)
Definition: filter_input.cc:19
impeller::FilterInput::Vector
std::vector< FilterInput::Ref > Vector
Definition: filter_input.h:33
impeller::Point
TPoint< Scalar > Point
Definition: point.h:327
impeller::BlendMode::kSrc
@ kSrc

References impeller::Paint::blend_mode, impeller::EntityPassClipStack::ClipStateResult::clip_did_change, impeller::Canvas::SaveLayerState::coverage, impeller::EntityPassClipStack::CurrentClipCoverage(), impeller::Entity::GetBlendMode(), impeller::Entity::GetContents(), impeller::Entity::GetCoverage(), impeller::ContentContext::GetDeviceCapabilities(), impeller::TRect< T >::GetOrigin(), impeller::Entity::GetTransform(), impeller::Matrix::Invert(), impeller::Entity::kLastPipelineBlendMode, impeller::kSrc, impeller::Entity::kSubpassAppendSnapshotTransform, impeller::Entity::kSubpassPrependSnapshotTransform, impeller::FilterInput::Make(), impeller::ColorFilterContents::MakeBlend(), impeller::Matrix::MakeTranslation(), impeller::Canvas::SaveLayerState::paint, impeller::EntityPassClipStack::PopSubpass(), impeller::EntityPassClipStack::RecordRestore(), impeller::Entity::Render(), impeller::Entity::SetBlendMode(), impeller::Entity::SetClipDepth(), impeller::Entity::SetContents(), impeller::Entity::SetTransform(), impeller::EntityPassClipStack::ClipStateResult::should_render, and impeller::Capabilities::SupportsFramebufferFetch().

Referenced by impeller::DlDispatcherBase::drawShadow(), DrawTextFrame(), impeller::DlDispatcherBase::restore(), and RestoreToCount().

## ◆ RestoreToCount()

void impeller::Canvas::RestoreToCount | ( | size_t | count | ) |

Definition at line 301 of file canvas.cc.

301 {
302 while (GetSaveCount() > count) {
303 if (!Restore()) {
304 return;
305 }
306 }
307 }
impeller::Canvas::GetSaveCount
size_t GetSaveCount() const
Definition: canvas.cc:293

References GetSaveCount(), and Restore().

Referenced by impeller::DlDispatcherBase::drawDisplayList().

## ◆ Rotate()

void impeller::Canvas::Rotate | ( | Radians | radians | ) |

Definition at line 274 of file canvas.cc.

274 {
275 Concat(Matrix::MakeRotationZ(radians));
276 }
impeller::Matrix::MakeRotationZ
static Matrix MakeRotationZ(Radians r)
Definition: matrix.h:223

References Concat(), and impeller::Matrix::MakeRotationZ().

Referenced by impeller::DlDispatcherBase::rotate().

## ◆ Save()

void impeller::Canvas::Save | ( | uint32_t | total_content_depth = `kMaxDepth` | ) |

Definition at line 1043 of file canvas.cc.

1043 {
1044 if (IsSkipping()) {
1045 return SkipUntilMatchingRestore(total_content_depth);
1046 }
1047
1048 auto entry = CanvasStackEntry{};
1049 entry.transform = transform_stack_.back().transform;
1050 entry.clip_depth = current_depth_ + total_content_depth;
1051 entry.distributed_opacity = transform_stack_.back().distributed_opacity;
1052 FML_DCHECK(entry.clip_depth <= transform_stack_.back().clip_depth)
1053 << entry.clip_depth << " <=? " << transform_stack_.back().clip_depth
1054 << " after allocating " << total_content_depth;
1055 entry.clip_height = transform_stack_.back().clip_height;
1056 entry.rendering_mode = Entity::RenderingMode::kDirect;
1057 transform_stack_.push_back(entry);
1058 }
impeller::Entity::RenderingMode::kDirect
@ kDirect

References impeller::Entity::kDirect, and impeller::CanvasStackEntry::transform.

Referenced by impeller::DlDispatcherBase::drawDisplayList(), impeller::DlDispatcherBase::drawShadow(), DrawTextFrame(), impeller::DlDispatcherBase::save(), and SaveLayer().

## ◆ SaveLayer()

void impeller::Canvas::SaveLayer | ( | const Paint & | paint,
|  | std::optional< Rect > | bounds = `std::nullopt`,
|  | const flutter::DlImageFilter * | backdrop_filter = `nullptr`,
|  | ContentBoundsPromise | bounds_promise = `ContentBoundsPromise::kUnknown`,
|  | uint32_t | total_content_depth = `kMaxDepth`,
|  | bool | can_distribute_opacity = `false`,
|  | std::optional< int64_t > | backdrop_id = `std::nullopt`
| ) |  |

Definition at line 1091 of file canvas.cc.

1097 {
1098 TRACE_EVENT0("flutter", "Canvas::saveLayer");
1099 if (IsSkipping()) {
1100 return SkipUntilMatchingRestore(total_content_depth);
1101 }
1102
1103 auto maybe_coverage_limit = GetLocalCoverageLimit();
1104 if (!maybe_coverage_limit.has_value()) {
1105 return SkipUntilMatchingRestore(total_content_depth);
1106 }
1107 auto coverage_limit = maybe_coverage_limit.value();
1108
1109 if (can_distribute_opacity && !backdrop_filter &&
1110 Paint::CanApplyOpacityPeephole(paint) &&
1111 bounds_promise != ContentBoundsPromise::kMayClipContents) {
1112 Save(total_content_depth);
1113 transform_stack_.back().distributed_opacity *= paint.color.alpha;
1114 return;
1115 }
1116
1117 std::shared_ptr<FilterContents> filter_contents = paint.WithImageFilter(
1118 Rect(), transform_stack_.back().transform,
1119 Entity::RenderingMode::kSubpassPrependSnapshotTransform);
1120
1121 std::optional<Rect> maybe_subpass_coverage = ComputeSaveLayerCoverage(
1122 bounds.value_or(Rect::MakeMaximum()),
1123 transform_stack_.back().transform, //
1124 coverage_limit, //
1125 filter_contents, //
1126 /*flood_output_coverage=*/
1127 Entity::IsBlendModeDestructive(paint.blend_mode), //
1128 /*flood_input_coverage=*/!!backdrop_filter ||
1129 (paint.color_filter &&
1130 paint.color_filter->modifies_transparent_black()) //
1131 );
1132
1133 if (!maybe_subpass_coverage.has_value()) {
1134 return SkipUntilMatchingRestore(total_content_depth);
1135 }
1136
1137 auto subpass_coverage = maybe_subpass_coverage.value();
1138
1139 // When an image filter is present, clamp to avoid flicking due to nearest
1140 // sampled image. For other cases, round out to ensure than any geometry is
1141 // not cut off.
1142 //
1143 // See also this bug: https://github.com/flutter/flutter/issues/144213
1144 //
1145 // TODO(jonahwilliams): this could still round out for filters that use decal
1146 // sampling mode.
1147 ISize subpass_size;
1148 bool did_round_out = false;
1149 Point coverage_origin_adjustment = Point{0, 0};
1150 if (paint.image_filter) {
1151 subpass_size = ISize(subpass_coverage.GetSize());
1152 } else {
1153 did_round_out = true;
1154 subpass_size =
1155 static_cast<ISize>(IRect::RoundOut(subpass_coverage).GetSize());
1156 // If rounding out, adjust the coverage to account for the subpixel shift.
1157 coverage_origin_adjustment =
1158 Point(subpass_coverage.GetLeftTop().x -
1159 std::floor(subpass_coverage.GetLeftTop().x),
1160 subpass_coverage.GetLeftTop().y -
1161 std::floor(subpass_coverage.GetLeftTop().y));
1162 }
1163 if (subpass_size.IsEmpty()) {
1164 return SkipUntilMatchingRestore(total_content_depth);
1165 }
1166
1167 // When there are scaling filters present, these contents may exceed the
1168 // maximum texture size. Perform a clamp here, which may cause rendering
1169 // artifacts.
1170 subpass_size = subpass_size.Min(renderer_.GetContext()
1171 ->GetCapabilities()
1172 ->GetMaximumRenderPassAttachmentSize());
1173
1174 // Backdrop filter state, ignored if there is no BDF.
1175 std::shared_ptr<FilterContents> backdrop_filter_contents;
1176 Point local_position = Point(0, 0);
1177 if (backdrop_filter) {
1178 local_position = subpass_coverage.GetOrigin() - GetGlobalPassPosition();
1179 Canvas::BackdropFilterProc backdrop_filter_proc =
1180 [backdrop_filter = backdrop_filter](
1181 const FilterInput::Ref& input, const Matrix& effect_transform,
1182 Entity::RenderingMode rendering_mode) {
1183 auto filter = WrapInput(backdrop_filter, input);
1184 filter->SetEffectTransform(effect_transform);
1185 filter->SetRenderingMode(rendering_mode);
1186 return filter;
1187 };
1188
1189 std::shared_ptr<Texture> input_texture;
1190
1191 // If the backdrop ID is not nullopt and there is more than one usage
1192 // of it in the current scene, cache the backdrop texture and remove it from
1193 // the current entity pass flip.
1194 bool will_cache_backdrop_texture = false;
1195 BackdropData* backdrop_data = nullptr;
1196 // If we've reached this point, there is at least one backdrop filter. But
1197 // potentially more if there is a backdrop id. We may conditionally set this
1198 // to a higher value in the if block below.
1199 size_t backdrop_count = 1;
1200 if (backdrop_id.has_value()) {
1201 std::unordered_map<int64_t, BackdropData>::iterator backdrop_data_it =
1202 backdrop_data_.find(backdrop_id.value());
1203 if (backdrop_data_it != backdrop_data_.end()) {
1204 backdrop_data = &backdrop_data_it->second;
1205 will_cache_backdrop_texture =
1206 backdrop_data_it->second.backdrop_count > 1;
1207 backdrop_count = backdrop_data_it->second.backdrop_count;
1208 }
1209 }
1210
1211 if (!will_cache_backdrop_texture || !backdrop_data->texture_slot) {
1212 backdrop_count_ -= backdrop_count;
1213
1214 // The onscreen texture can be flipped to if:
1215 // 1. The device supports framebuffer fetch
1216 // 2. There are no more backdrop filters
1217 // 3. The current render pass is for the onscreen pass.
1218 const bool should_use_onscreen =
1219 renderer_.GetDeviceCapabilities().SupportsFramebufferFetch() &&
1220 backdrop_count_ == 0 && render_passes_.size() == 1u;
1221 input_texture = FlipBackdrop(
1222 GetGlobalPassPosition(), //
1223 /*should_remove_texture=*/will_cache_backdrop_texture, //
1224 /*should_use_onscreen=*/should_use_onscreen //
1225 );
1226 if (!input_texture) {
1227 // Validation failures are logged in FlipBackdrop.
1228 return;
1229 }
1230
1231 if (will_cache_backdrop_texture) {
1232 backdrop_data->texture_slot = input_texture;
1233 }
1234 } else {
1235 input_texture = backdrop_data->texture_slot;
1236 }
1237
1238 backdrop_filter_contents = backdrop_filter_proc(
1239 FilterInput::Make(std::move(input_texture)),
1240 transform_stack_.back().transform.Basis(),
1241 // When the subpass has a translation that means the math with
1242 // the snapshot has to be different.
1243 transform_stack_.back().transform.HasTranslation()
1244 ? Entity::RenderingMode::kSubpassPrependSnapshotTransform
1245 : Entity::RenderingMode::kSubpassAppendSnapshotTransform);
1246
1247 if (will_cache_backdrop_texture) {
1248 FML_DCHECK(backdrop_data);
1249 // If all filters on the shared backdrop layer are equal, process the
1250 // layer once.
1251 if (backdrop_data->all_filters_equal &&
1252 !backdrop_data->shared_filter_snapshot.has_value()) {
1253 // TODO(157110): compute minimum input hint.
1254 backdrop_data->shared_filter_snapshot =
1255 backdrop_filter_contents->RenderToSnapshot(renderer_, {});
1256 }
1257
1258 std::optional<Snapshot> maybe_snapshot =
1259 backdrop_data->shared_filter_snapshot;
1260 if (maybe_snapshot.has_value()) {
1261 Snapshot snapshot = maybe_snapshot.value();
1262 std::shared_ptr<TextureContents> contents = TextureContents::MakeRect(
1263 subpass_coverage.Shift(-GetGlobalPassPosition()));
1264 auto scaled =
1265 subpass_coverage.TransformBounds(snapshot.transform.Invert());
1266 contents->SetTexture(snapshot.texture);
1267 contents->SetSourceRect(scaled);
1268 contents->SetSamplerDescriptor(snapshot.sampler_descriptor);
1269
1270 // This backdrop entity sets a depth value as it is written to the newly
1271 // flipped backdrop and not into a new saveLayer.
1272 Entity backdrop_entity;
1273 backdrop_entity.SetContents(std::move(contents));
1274 backdrop_entity.SetClipDepth(++current_depth_);
1275 backdrop_entity.SetBlendMode(paint.blend_mode);
1276
1277 backdrop_entity.Render(renderer_, GetCurrentRenderPass());
1278 Save(0);
1279 return;
1280 }
1281 }
1282 }
1283
1284 // When applying a save layer, absorb any pending distributed opacity.
1285 Paint paint_copy = paint;
1286 paint_copy.color.alpha *= transform_stack_.back().distributed_opacity;
1287 transform_stack_.back().distributed_opacity = 1.0;
1288
1289 render_passes_.push_back(
1290 LazyRenderingConfig(renderer_, //
1291 CreateRenderTarget(renderer_, //
1292 subpass_size, //
1293 Color::BlackTransparent() //
1294 )));
1295 save_layer_state_.push_back(SaveLayerState{
1296 paint_copy, subpass_coverage.Shift(-coverage_origin_adjustment)});
1297
1298 CanvasStackEntry entry;
1299 entry.transform = transform_stack_.back().transform;
1300 entry.clip_depth = current_depth_ + total_content_depth;
1301 FML_DCHECK(entry.clip_depth <= transform_stack_.back().clip_depth)
1302 << entry.clip_depth << " <=? " << transform_stack_.back().clip_depth
1303 << " after allocating " << total_content_depth;
1304 entry.clip_height = transform_stack_.back().clip_height;
1305 entry.rendering_mode = Entity::RenderingMode::kSubpassAppendSnapshotTransform;
1306 entry.did_round_out = did_round_out;
1307 transform_stack_.emplace_back(entry);
1308
1309 // Start non-collapsed subpasses with a fresh clip coverage stack limited by
1310 // the subpass coverage. This is important because image filters applied to
1311 // save layers may transform the subpass texture after it's rendered,
1312 // causing parent clip coverage to get misaligned with the actual area that
1313 // the subpass will affect in the parent pass.
1314 clip_coverage_stack_.PushSubpass(subpass_coverage, GetClipHeight());
1315
1316 if (!backdrop_filter_contents) {
1317 return;
1318 }
1319
1320 // Render the backdrop entity.
1321 Entity backdrop_entity;
1322 backdrop_entity.SetContents(std::move(backdrop_filter_contents));
1323 backdrop_entity.SetTransform(
1324 Matrix::MakeTranslation(Vector3(-local_position)));
1325 backdrop_entity.SetClipDepth(std::numeric_limits<uint32_t>::max());
1326 backdrop_entity.Render(renderer_, GetCurrentRenderPass());
1327 }
impeller::Canvas::GetLocalCoverageLimit
std::optional< Rect > GetLocalCoverageLimit() const
Return the culling bounds of the current render target, or nullopt if there is no coverage.
Definition: canvas.cc:1060
impeller::Canvas::BackdropFilterProc
std::function< std::shared_ptr< FilterContents >(FilterInput::Ref, const Matrix &effect_transform, Entity::RenderingMode rendering_mode)> BackdropFilterProc
Definition: canvas.h:123
impeller::Entity::RenderingMode
RenderingMode
Definition: entity.h:27
impeller::Entity::IsBlendModeDestructive
static bool IsBlendModeDestructive(BlendMode blend_mode)
Returns true if the blend mode is "destructive", meaning that even fully transparent source colors wo...
Definition: entity.cc:127
impeller::EntityPassClipStack::PushSubpass
void PushSubpass(std::optional< Rect > subpass_coverage, size_t clip_height)
Definition: entity_pass_clip_stack.cc:32
impeller::FilterInput::Ref
std::shared_ptr< FilterInput > Ref
Definition: filter_input.h:32
subpass_size
ISize subpass_size
The output size of the down-sampling pass.
Definition: gaussian_blur_filter_contents.cc:202
impeller::WrapInput
std::shared_ptr< FilterContents > WrapInput(const flutter::DlImageFilter *filter, const FilterInput::Ref &input)
Generate a new FilterContents using this filter's configuration.
Definition: image_filter.cc:18
impeller::ContentBoundsPromise::kMayClipContents
@ kMayClipContents
The caller claims the bounds are a subset of an estimate of the reasonably tight bounds but likely cl...
impeller::ComputeSaveLayerCoverage
std::optional< Rect > ComputeSaveLayerCoverage(const Rect &content_coverage, const Matrix &effect_transform, const Rect &coverage_limit, const std::shared_ptr< FilterContents > &image_filter, bool flood_output_coverage, bool flood_input_coverage)
Compute the coverage of a subpass in the global coordinate space.
Definition: save_layer_utils.cc:19
impeller::Color::BlackTransparent
static constexpr Color BlackTransparent()
Definition: color.h:270
impeller::Paint::CanApplyOpacityPeephole
static bool CanApplyOpacityPeephole(const Paint &paint)
Whether or not a save layer with the provided paint can perform the opacity peephole optimization.
Definition: paint.h:39
impeller::TRect::RoundOut
RoundOut(const TRect< U > &r)
Definition: rect.h:683
impeller::TRect< Scalar >::MakeMaximum
constexpr static TRect MakeMaximum()
Definition: rect.h:188

References impeller::BackdropData::all_filters_equal, impeller::Color::alpha, impeller::BackdropData::backdrop_count, impeller::Color::BlackTransparent(), impeller::Paint::blend_mode, impeller::Paint::CanApplyOpacityPeephole(), impeller::CanvasStackEntry::clip_depth, impeller::CanvasStackEntry::clip_height, impeller::Paint::color, impeller::Paint::color_filter, impeller::ComputeSaveLayerCoverage(), impeller::CanvasStackEntry::did_round_out, impeller::ContentContext::GetContext(), impeller::ContentContext::GetDeviceCapabilities(), GetLocalCoverageLimit(), impeller::Paint::image_filter, impeller::Matrix::Invert(), impeller::Entity::IsBlendModeDestructive(), impeller::kMayClipContents, impeller::Entity::kSubpassAppendSnapshotTransform, impeller::Entity::kSubpassPrependSnapshotTransform, impeller::FilterInput::Make(), impeller::TRect< Scalar >::MakeMaximum(), impeller::TextureContents::MakeRect(), impeller::Matrix::MakeTranslation(), impeller::EntityPassClipStack::PushSubpass(), impeller::Entity::Render(), impeller::CanvasStackEntry::rendering_mode, impeller::TRect< T >::RoundOut(), impeller::Snapshot::sampler_descriptor, Save(), impeller::Entity::SetBlendMode(), impeller::Entity::SetClipDepth(), impeller::Entity::SetContents(), impeller::Entity::SetTransform(), impeller::BackdropData::shared_filter_snapshot, subpass_size, impeller::Capabilities::SupportsFramebufferFetch(), impeller::Snapshot::texture, impeller::BackdropData::texture_slot, impeller::CanvasStackEntry::transform, impeller::Snapshot::transform, impeller::Paint::WithImageFilter(), and impeller::WrapInput().

Referenced by impeller::DlDispatcherBase::drawDisplayList(), and impeller::DlDispatcherBase::saveLayer().

## ◆ Scale() [1/2]

void impeller::Canvas::Scale | ( | const Vector2 & | scale | ) |

Definition at line 262 of file canvas.cc.

262 {
263 Concat(Matrix::MakeScale(scale));
264 }
scale
const Scalar scale
Definition: stroke_path_geometry.cc:319
impeller::Matrix::MakeScale
static constexpr Matrix MakeScale(const Vector3 &s)
Definition: matrix.h:104

References Concat(), impeller::Matrix::MakeScale(), and scale.

Referenced by impeller::DlDispatcherBase::scale().

## ◆ Scale() [2/2]

void impeller::Canvas::Scale | ( | const Vector3 & | scale | ) |

Definition at line 266 of file canvas.cc.

266 {
267 Concat(Matrix::MakeScale(scale));
268 }

References Concat(), impeller::Matrix::MakeScale(), and scale.

## ◆ SetBackdropData()

void impeller::Canvas::SetBackdropData | ( | std::unordered_map< int64_t, BackdropData > | backdrop_data,
|  | size_t | backdrop_count
| ) |  |

Update the backdrop data used to group together backdrop filters within the same layer.

Definition at line 1742 of file canvas.cc.

1744 {
1745 backdrop_data_ = std::move(backdrop_data);
1746 backdrop_count_ = backdrop_count;
1747 }

Referenced by impeller::CanvasDlDispatcher::SetBackdropData().

## ◆ Skew()

void impeller::Canvas::Skew | ( | Scalar | sx,
|  | Scalar | sy
| ) |  |

Definition at line 270 of file canvas.cc.

270 {
271 Concat(Matrix::MakeSkew(sx, sy));
272 }
impeller::Matrix::MakeSkew
static constexpr Matrix MakeSkew(Scalar sx, Scalar sy)
Definition: matrix.h:127

References Concat(), and impeller::Matrix::MakeSkew().

Referenced by impeller::DlDispatcherBase::skew().

## ◆ SupportsBlitToOnscreen()

bool impeller::Canvas::SupportsBlitToOnscreen | ( |  | ) | const

Definition at line 1868 of file canvas.cc.

1868 {
1869 return renderer_.GetContext()
1870 ->GetCapabilities()
1871 ->SupportsTextureToTextureBlits() &&
1872 renderer_.GetContext()->GetBackendType() ==
1873 Context::BackendType::kMetal;
1874 }
impeller::Context::BackendType::kMetal
@ kMetal

## ◆ Transform()

void impeller::Canvas::Transform | ( | const Matrix & | transform | ) |

Definition at line 250 of file canvas.cc.

250 {
251 Concat(transform);
252 }

References Concat(), and transform.

Referenced by impeller::DlDispatcherBase::transformFullPerspective(), and impeller::DlDispatcherBase::transformReset().

## ◆ Translate()

void impeller::Canvas::Translate | ( | const Vector3 & | offset | ) |

Definition at line 258 of file canvas.cc.

258 {
259 Concat(Matrix::MakeTranslation(offset));
260 }

References Concat(), impeller::Matrix::MakeTranslation(), and offset.

Referenced by impeller::DlDispatcherBase::translate().

## Member Data Documentation

## ◆ kMaxDepth

constexpr uint32_t impeller::Canvas::kMaxDepth = 1 << 24
| static constexpr

Definition at line 118 of file canvas.h.

The documentation for this class was generated from the following files:

- impeller/display_list/canvas.h
- impeller/display_list/canvas.cc